KCommandHistory Class Reference

`#include <kcommand.h>`

Inherits QObject.

## Public Slots

virtual void | undo ()
virtual void | redo ()
virtual void | documentSaved ()

## Signals

void | commandExecuted ()
void | commandExecuted (KCommand *command)
void | documentRestored ()

## Public Member Functions

| KCommandHistory ()
| KCommandHistory (KActionCollection *actionCollection, bool withMenus=true)
virtual | ~KCommandHistory ()
void | clear ()
void | addCommand (KCommand *command, bool execute=true)
int | undoLimit () const
void | setUndoLimit (int limit)
int | redoLimit () const
void | setRedoLimit (int limit)
void | updateActions ()

## Protected Slots

void | slotUndoAboutToShow ()
void | slotUndoActivated (int)
void | slotRedoAboutToShow ()
void | slotRedoActivated (int)

## Protected Member Functions

virtual void | virtual_hook (int id, void *data)

## Detailed Description

The command history stores a (user) configurable amount of Commands.

It keeps track of its size and deletes commands if it gets too large. The user can set a maximum undo and a maximum redo limit (e.g. max. 50 undo / 30 redo commands). The KCommandHistory keeps track of the "borders" and deletes commands, if appropriate. It also activates/deactivates the undo/redo actions in the menu and changes the text according to the name of the command.

Definition at line 156 of file kcommand.h.

## Constructor & Destructor Documentation

KCommandHistory::KCommandHistory | ( |  | ) |

Creates a command history, to store commands.

This constructor doesn't create actions, so you need to call undo and redo yourself.

Definition at line 72 of file kcommand.cpp.

KCommandHistory::KCommandHistory | ( | KActionCollection * | actionCollection,
|  | bool | withMenus = `true`
| ) |  |

Creates a command history, to store commands.

This also creates an undo and a redo action, in the `actionCollection`, using the standard names ("edit_undo" and "edit_redo").

Parameters

  withMenus | if true, the actions will display a menu when plugged into a toolbar.
  actionCollection | the parent collection

Definition at line 80 of file kcommand.cpp.

KCommandHistory::~KCommandHistory | ( |  | ) |

virtual

Destructs the command history object.

Definition at line 113 of file kcommand.cpp.

## Member Function Documentation

void KCommandHistory::addCommand | ( | KCommand * | command,
|  | bool | execute = `true`
| ) |  |

Adds a command to the history.

Call this for each `command` you create. Unless you set `execute` to false, this will also execute the command. This means, most of the application's code will look like MyCommand * cmd = new MyCommand(i18n("Capitalized Name"), parameters); m_historyCommand.addCommand( cmd );

Definition at line 130 of file kcommand.cpp.

void KCommandHistory::clear | ( |  | ) |

Erases all the undo/redo history.

Use this when reloading the data, for instance, since this invalidates all the commands.

Definition at line 117 of file kcommand.cpp.

void KCommandHistory::commandExecuted | ( |  | ) |

signal

Emitted every time a command is executed (whether by addCommand, undo or redo).

You can use this to update the GUI, for instance.

KDE4 TODO: remove

void KCommandHistory::commandExecuted | ( | KCommand * | command | ) |

signal

Emitted every time a command is executed (whether by addCommand, undo or redo).

You can use this to update the GUI, for instance.

Parameters

  command | was executed

Since
  3.5

void KCommandHistory::documentRestored | ( |  | ) |

signal

Emitted every time we reach the index where you saved the document for the last time.

See documentSaved

void KCommandHistory::documentSaved | ( |  | ) |

virtual slot

Remembers when you saved the document.

Call this right after saving the document. As soon as the history reaches the current index again (via some undo/redo operations) it will emit documentRestored If you implemented undo/redo properly the document is the same you saved before.

Definition at line 258 of file kcommand.cpp.

void KCommandHistory::redo | ( |  | ) |

virtual slot

Redoes the last undone action.

Call this if you don't use the builtin KActions.

Definition at line 217 of file kcommand.cpp.

int KCommandHistory::redoLimit | ( |  | ) | const

inline

Returns
  the maximum number of items in the redo history

Definition at line 208 of file kcommand.h.

void KCommandHistory::setRedoLimit | ( | int | limit | ) |

Sets the maximum number of items in the redo history.

Definition at line 276 of file kcommand.cpp.

void KCommandHistory::setUndoLimit | ( | int | limit | ) |

Sets the maximum number of items in the undo history.

Definition at line 268 of file kcommand.cpp.

void KCommandHistory::undo | ( |  | ) |

virtual slot

Undoes the last action.

Call this if you don't use the builtin KActions.

Definition at line 182 of file kcommand.cpp.

int KCommandHistory::undoLimit | ( |  | ) | const

inline

Returns
  the maximum number of items in the undo history

Definition at line 200 of file kcommand.h.

void KCommandHistory::updateActions | ( |  | ) |

Enable or disable the undo and redo actions.

This isn't usually necessary, but this method can be useful if you disable all actions (to go to a "readonly" state), and then want to come back to a readwrite mode.

Definition at line 358 of file kcommand.cpp.

The documentation for this class was generated from the following files:

- kcommand.h
- kcommand.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys